program Client;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  Classes,
  orb_int,
  orb,
  poa_int,
  poa_impl,
  exceptions,
  except_int,
  orbtypes,
  hello_int,
  hello;

procedure mainproc;
var
  dorb : IORB;
  obj: IORBObject;
  myobj: IHello;
  props: TStrings;
  i: integer;
  ex: ISystemException;
  str: string;
  wstr: WideString;
  c: char;
  cs: TChars;
  wc: widechar;
  wcs: TwChars;
  f: Text;
begin
  props := TStringList.Create;
  try
    for i := 1 to ParamCount do
      props.Add(ParamStr(i));
    dorb := ORB_Init(props);
  finally
    props.Free;
  end; { try/finally }
  obj := dorb.bind('IDL:Hello:1.0');
  if obj <> nil then begin
    myobj := THello._narrow(obj);
    if myobj = nil then Exit;
    try
      c := myobj.hello_char(''); // russian language, KOI8-R
      SetLength(cs, 6);
      move(PChar('')^, Pointer(cs)^, 6); // russian language, KOI8-R
      cs := myobj.hello_chars(cs);
      str := myobj.hello_string(''); // russian language, KOI8-R
      SetLength(wcs, 5);
      wstr := ''; // russian language
      wc := myobj.hello_widechar(wstr[1]);
      move(Pointer(wstr)^, Pointer(wcs)^, 5 * SizeOf(WideChar));
      wcs := myobj.hello_widechars(wcs);
      wstr := '';
      wstr := myobj.hello_widesting(WideString('')); // russian language
      AssignFile(f, 'Client.txt');
      Rewrite(f);
      WriteLn(f, c);
      for i := 0 to Length(cs) - 1 do
        Write(f, cs[i]);
      WriteLn(f);
      WriteLn(f, str);
      WriteLn(f, wc);
      for i := 0 to Length(wcs) - 1 do
        Write(f, wcs[i]);
      WriteLn(f);
      WriteLn(f, wstr);
      CloseFile(f);
      WriteLn('Successfully complete. Press any key.');
      ReadLn;
    except
      on E: SystemException do begin
        ex := SystemException.Create(E);
        WriteLn('Corba exception: ', SYSEXC_NAMES[ex.extype()]);
        ReadLn;
      end;
    end; { try/except }
  end;
end;

begin
  mainproc;
end.